﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="ucDatosInformeResumenMI.ascx.cs" Inherits="Web.UserControls.ucDatosInformeResumenMI" %>

<%@ Register TagPrefix="ej" Namespace="Syncfusion.JavaScript.Models" Assembly="Syncfusion.EJ" %>
<%@ Register TagPrefix="ej" Namespace="Syncfusion.JavaScript.DataVisualization.Models" Assembly="Syncfusion.EJ" %>
<div class="container">
    <asp:HiddenField runat="server" ID="hiddenAño" />
    <asp:HiddenField runat="server" ID="hiddenNumeroSemana" />

    <div class="row">
        <h3>
            <asp:Label runat="server" ID="lblTitulo" /></h3>
        <ej:Grid ID="gridResumenMI" runat="server" AllowSorting="True" ShowStackedHeader="true" AllowResizeToFit="true" AllowFiltering="true" AllowPaging="true" AllowGrouping="true">
            <PageSettings PageSize="5" />
            <FilterSettings FilterType="Excel" />
            <ClientSideEvents ActionComplete="onGridActionComplete" DataBound="onGridDataBound" />
            <ToolbarSettings ShowToolbar="true" ToolbarItems="excelExport"></ToolbarSettings>
            <GroupSettings GroupedColumns="Status" />


            <SummaryRows>
                <ej:SummaryRow Title="Total">
                    <SummaryColumn>
                        <ej:SummaryColumn SummaryType="Sum" DisplayColumn="Week1" DataMember="Week1" />
                        <ej:SummaryColumn SummaryType="Sum" DisplayColumn="Week2" DataMember="Week2" />
                        <ej:SummaryColumn SummaryType="Sum" DisplayColumn="Week3" DataMember="Week3" />
                        <ej:SummaryColumn SummaryType="Sum" DisplayColumn="Week4" DataMember="Week4" />
                        <ej:SummaryColumn SummaryType="Sum" DisplayColumn="Week5" DataMember="Week5" />
                        <ej:SummaryColumn SummaryType="Sum" DisplayColumn="Week6" DataMember="Week6" />
                        <ej:SummaryColumn SummaryType="Sum" DisplayColumn="Week7" DataMember="Week7" />
                        <ej:SummaryColumn SummaryType="Sum" DisplayColumn="Week8" DataMember="Week8" />
                        <ej:SummaryColumn SummaryType="Sum" DisplayColumn="Week9" DataMember="Week9" />
                        <ej:SummaryColumn SummaryType="Sum" DisplayColumn="Week10" DataMember="Week10" />
                    </SummaryColumn>
                </ej:SummaryRow>
            </SummaryRows>

            <Columns>
                <ej:Column Field="CustomerID" HeaderText="Order ID" IsPrimaryKey="True" TextAlign="Right" Width="75" />
                <ej:Column Field="Status" HeaderText="Status" TextAlign="Right" Width="75" />
                <ej:Column Field="Week1" Width="80" AllowFiltering="false" />
                 <ej:Column Field="Week2" Width="80" AllowFiltering="false"/>
                 <ej:Column Field="Week3" Width="80" AllowFiltering="false"/>
                 <ej:Column Field="Week4" Width="80" AllowFiltering="false"/>
                 <ej:Column Field="Week5" Width="80" AllowFiltering="false" Visible ="false"/>
                 <ej:Column Field="Week6" Width="80" AllowFiltering="false" Visible ="false"/>
                 <ej:Column Field="Week7" Width="80" AllowFiltering="false" Visible ="false"/>
                 <ej:Column Field="Week8" Width="80" AllowFiltering="false" Visible ="false"/>
                 <ej:Column Field="Week9" Width="80" AllowFiltering="false" Visible ="false"/>
                 <ej:Column Field="Week10" Width="80" AllowFiltering="false" Visible ="false"/>
            </Columns>
        </ej:Grid>
    </div>

    <ej:Chart ID="chartInforme" runat="server" OnClientCreate="onChartCreated">
<%--        <Series>
        </Series>--%>
    </ej:Chart>

</div>

<script>

    var chart;
    var grid;
    var dataSource;

    function onChartCreated(sender) {
        // chart = sender;
        chart = $("#" + sender.model.clientId).ejChart("instance");
        dataSource = grid.model.dataSource;
        bindChartWithGrid();
    }


    function onGridDataBound(sender)
    {
        grid = sender;
        bindChartWithGrid();
    }

    function onGridActionComplete(sender) {
        if (sender.requestType == "filtering") {
            dataSource = null;
            bindChartWithGrid()
        }
    }

    function bindChartWithGrid() {
        // check if grid and chart are loaded
        if (grid == undefined || chart == undefined) 
            return;

        
        if (grid.model.allowGrouping)
            dataSource = grid.model.currentViewData.records;
        else
            dataSource = grid.model.currentViewData;

        var columnas = []
        var SeriesDataSources = [];
        var serie = [];

        // Get visible weeks
        for(var i = 0; i < grid.model.columns.length; i ++)
        {
            if (grid.model.columns[i].visible == true && grid.model.columns[i].field.startsWith("Week"))
                columnas.push(grid.model.columns[i].field);
        }


        for (var i = 0; i < dataSource.length; i++) {
            var objectProperties = Object.getOwnPropertyNames(dataSource[i]);

            //alert(dataSource[i].GrupoOS);

            // Browse object properties, and those that match the columns displayed stored value to create the chart
            var cont = 0;
            for (var j = 0; j < objectProperties.length; j++) {
                
                if ($.inArray(objectProperties[j], columnas) > -1) {
                    //alert(objectProperties[j]);
                    var dato = dataSource[i];
                    punto = { serieName: dato.CustomerID, Week: columnas[cont], Total: dato[objectProperties[j]] };
                    //alert("NameSerie: " + punto.serieName +  " Week: " + punto.Semana + " total: " + punto.Total);
                    serie.push(punto);
                    cont++;
                }
            }

            if (serie.length > 0) {
                
                SeriesDataSources.push(serie);
                serie = [];
            }
        }

        chart.model.series = [];        
        for (h = 0; h < SeriesDataSources.length; h++) {
            chart.model.series[h] = {};
            chart.model.series[h].dataSource = SeriesDataSources[h];
            chart.model.series[h].xName = "Week";
            chart.model.series[h].yName = "Total";
            chart.model.series[h].name = SeriesDataSources[h][0].serieName;
            chart.model.series[h].type = "Column";
            chart.model.series[h].enableAnimation = true;
        }

        //chart.model.series = [];
        SeriesDataSources = [];
        alert("before redraw");
       // console.log(chart);
         chart.redraw();
        alert("done");
    }
</script>
