﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace Web.UserControls
{
    public partial class ucDatosInformeResumenMI : System.Web.UI.UserControl
    {

        public Syncfusion.JavaScript.Web.Grid Grid { get { return gridResumenMI; } }

        protected void Page_Load(object sender, EventArgs e)
        {
            ScriptManager scriptManager = ScriptManager.GetCurrent(this.Page);
            scriptManager.RegisterPostBackControl(this.FindControl("gridResumenMI"));  //control id
        }


        public void SetDataSource(IEnumerable<Orders> listaDatos, int indexWeekVisible, string status)
        {
            gridResumenMI.DataSource = null;
            gridResumenMI.DataSource = listaDatos.Where( x => x.Status == status).ToList();
            gridResumenMI.DataBind();


            // Hidde columns with value < indexWeekVisible
            foreach (var column in gridResumenMI.Columns.Where(x => x.Field.StartsWith("Week")))
            {
                int numero = 0;
                if (Int32.TryParse(column.Field.Remove(0, 4), out numero))
                    column.Visible = (numero <= indexWeekVisible);
            }
        }

        public void SetDataSource(IEnumerable<Orders> listaDatos, int indexWeekVisible)
        {
            gridResumenMI.DataSource = null;
            gridResumenMI.DataSource = listaDatos.ToList();
            gridResumenMI.DataBind();


            // Hidde columns with value < indexWeekVisible
            foreach (var column in gridResumenMI.Columns.Where(x => x.Field.StartsWith("Week")))
            {
                int numero = 0;
                if (Int32.TryParse(column.Field.Remove(0, 4), out numero))
                    column.Visible = (numero <= indexWeekVisible);
            }
        }
    }
}